;**********************	Software Single Master I2C Driver ***************
$nocond nosb
;ExtAdrMode	equ 0		;24C02 ... 24C16
ExtAdrMode	equ 1		;24C164, 24C32 ... 24C256

SSDA	bit p1.0
SSCL	bit p1.1

;CYCLE_1ms	equ 2000	;Cycle per 1ms at 24MHz
;CYCLE_1ms	equ 922		;at 11.0592MHz
;CYCLE_1ms	equ 1667	;at 20MHz
Cycle_1ms	equ 1000	;at 12MHz

	using 0			;register bank 0 used

main:
;			reset the I2C bus
;			e.g. if the 8051 was reset during I2C bus transfer
	call si2cres

;			write to PCF8574
	mov r7, #70h		;write address
	mov a, #34h
	call p8574wr

;			read from PCF8574
	mov r7, #71h		;read address
	call p8574rd

;			block write to X24C64
	mov r7, #1
	mov r6, #6		;at address 0106h
	mov r5, #5		;write 5 byte
	mov r0, #30h		;from ram address 30h ... 34h
	call seepwr

;			block read from X24XC64
	mov r7, #1
	mov r6, #6		;at address 0106h
	mov r5, #5		;read 5 byte
	mov r0, #30h		;to ram address 30h ... 34h
	call seeprd

;			write single byte to X24C64
	mov r4, #0ABh		;load value to R4
	mov r0, #ar4		;point to R4
	mov r7, #12h		;address: 1234h
	mov r6, #34h
	mov r5, #1
	call seepwr

;			read single byte from X24C64
	mov r7, #12h
	mov r6, #34h
	mov r5, #1
	mov r0, #ar4
	call seeprd		;read 1 byte to R4

	sjmp $

$include(si2c_drv.inc)
$include(x24c16.inc)
$include(p8574.inc)

end
